
# ----------------------------------------
# MKP01 PROBLEM
# USING cover inequalities
# ----------------------------------------


### MASTER PROBLEM 
# -----------------

set     Item;
set     Axis;
param   Profit    {j in Item}                   >=0;
param   Capacity  {i in Axis}                   >=0;
param   Weight    {i in Axis, j in Item}        >=0;

param   nCov                                    integer >= 0, default 0;
set     Cover := 1..nCov;
param   Cardinality {i in Cover}                integer > 0;
param   CoverCoeff  {Cover,Item}                >= 0;

var     x       {Item} integer >= 0 <= 1;       # item chosen


maximize TotalProfit:
   sum {j in Item} Profit[j] * x[j];

subj to KnapsackCapacity {i in Axis}:
   sum {j in Item} Weight[i,j] * x[j] <= Capacity[i];

subj to CoverIneq {k in Cover}:
   sum {j in Item} CoverCoeff[k,j] * x[j] <= Cardinality[k] - 1;


### SLAVE SEPARATION PROBLEM
# ---------------------------

param   CoverCost   {Item}  >= 0;   # profit for cover problem
param   CoverWeight {Item}  >= 0;   # weight for cover problem
param   CoverCapacity       >= 0;   # cover cardinality

var     z       {Item}  binary;     # Item in cover

minimize CoverViolation:
   sum {j in Item} CoverCost[j] * z[j];

subj to CoverDemand:
   sum {j in Item} CoverWeight[j] * z[j] >= CoverCapacity + 1;

